Index: cprs/trunk/CPRS-Lib/ORCtrlLib2006.dproj
===================================================================
--- cprs/trunk/CPRS-Lib/ORCtrlLib2006.dproj	(revision 1683)
+++ cprs/trunk/CPRS-Lib/ORCtrlLib2006.dproj	(revision 1727)
@@ -1,6 +1,7 @@
-﻿<Project xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
   <PropertyGroup>
     <ProjectGuid>{da052835-cc1a-47fb-aa80-83418bab640b}</ProjectGuid>
-    <MainSource>ORCtrlLib2006.dpk</MainSource>
+    <MainSource>E:\WVEHR\trunk\CPRS-Lib\ORCtrlLib2006.dpk</MainSource>
     <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
     <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
@@ -33,5 +34,9 @@
     <Borland.ProjectType>Package</Borland.ProjectType>
     <BorlandProject>
-<BorlandProject><Delphi.Personality><Parameters><Parameters Name="UseLauncher">False</Parameters><Parameters Name="LoadAllSymbols">True</Parameters><Parameters Name="LoadUnspecifiedSymbols">False</Parameters></Parameters><Package_Options><Package_Options Name="PackageDescription">CPRS Custom Controls</Package_Options><Package_Options Name="ImplicitBuild">True</Package_Options><Package_Options Name="DesigntimeOnly">True</Package_Options><Package_Options Name="RuntimeOnly">False</Package_Options></Package_Options><VersionInfo><VersionInfo Name="IncludeVerInfo">True</VersionInfo><VersionInfo Name="AutoIncBuild">False</VersionInfo><VersionInfo Name="MajorVer">1</VersionInfo><VersionInfo Name="MinorVer">0</VersionInfo><VersionInfo Name="Release">0</VersionInfo><VersionInfo Name="Build">0</VersionInfo><VersionInfo Name="Debug">False</VersionInfo><VersionInfo Name="PreRelease">False</VersionInfo><VersionInfo Name="Special">False</VersionInfo><VersionInfo Name="Private">False</VersionInfo><VersionInfo Name="DLL">False</VersionInfo><VersionInfo Name="Locale">1033</VersionInfo><VersionInfo Name="CodePage">1252</VersionInfo></VersionInfo><VersionInfoKeys><VersionInfoKeys Name="CompanyName"></VersionInfoKeys><VersionInfoKeys Name="FileDescription"></VersionInfoKeys><VersionInfoKeys Name="FileVersion">1.0.0.0</VersionInfoKeys><VersionInfoKeys Name="InternalName"></VersionInfoKeys><VersionInfoKeys Name="LegalCopyright"></VersionInfoKeys><VersionInfoKeys Name="LegalTrademarks"></VersionInfoKeys><VersionInfoKeys Name="OriginalFilename"></VersionInfoKeys><VersionInfoKeys Name="ProductName"></VersionInfoKeys><VersionInfoKeys Name="ProductVersion">1.0.0.0</VersionInfoKeys><VersionInfoKeys Name="Comments"></VersionInfoKeys></VersionInfoKeys><Source><Source Name="MainSource">ORCtrlLib2006.dpk</Source></Source></Delphi.Personality></BorlandProject></BorlandProject>
+<BorlandProject><Delphi.Personality><Parameters><Parameters Name="UseLauncher">False</Parameters><Parameters Name="LoadAllSymbols">True</Parameters><Parameters Name="LoadUnspecifiedSymbols">False</Parameters></Parameters><Package_Options><Package_Options Name="PackageDescription">CPRS Custom Controls</Package_Options><Package_Options Name="ImplicitBuild">False</Package_Options><Package_Options Name="DesigntimeOnly">True</Package_Options><Package_Options Name="RuntimeOnly">False</Package_Options></Package_Options><VersionInfo><VersionInfo Name="IncludeVerInfo">True</VersionInfo><VersionInfo Name="AutoIncBuild">False</VersionInfo><VersionInfo Name="MajorVer">1</VersionInfo><VersionInfo Name="MinorVer">0</VersionInfo><VersionInfo Name="Release">0</VersionInfo><VersionInfo Name="Build">0</VersionInfo><VersionInfo Name="Debug">False</VersionInfo><VersionInfo Name="PreRelease">False</VersionInfo><VersionInfo Name="Special">False</VersionInfo><VersionInfo Name="Private">False</VersionInfo><VersionInfo Name="DLL">False</VersionInfo><VersionInfo Name="Locale">1033</VersionInfo><VersionInfo Name="CodePage">1252</VersionInfo></VersionInfo><VersionInfoKeys><VersionInfoKeys Name="CompanyName"></VersionInfoKeys><VersionInfoKeys Name="FileDescription"></VersionInfoKeys><VersionInfoKeys Name="FileVersion">1.0.0.0</VersionInfoKeys><VersionInfoKeys Name="InternalName"></VersionInfoKeys><VersionInfoKeys Name="LegalCopyright"></VersionInfoKeys><VersionInfoKeys Name="LegalTrademarks"></VersionInfoKeys><VersionInfoKeys Name="OriginalFilename"></VersionInfoKeys><VersionInfoKeys Name="ProductName"></VersionInfoKeys><VersionInfoKeys Name="ProductVersion">1.0.0.0</VersionInfoKeys><VersionInfoKeys Name="Comments"></VersionInfoKeys></VersionInfoKeys><Source><Source Name="MainSource">E:\WVEHR\trunk\CPRS-Lib\ORCtrlLib2006.dpk</Source></Source><Excluded_Packages>
+      
+      
+      <Excluded_Packages Name="$(BDS)\bin\dclofficexp100.bpl">Microsoft Office XP Sample Automation Server Wrapper Components</Excluded_Packages>
+    </Excluded_Packages></Delphi.Personality></BorlandProject></BorlandProject>
   </ProjectExtensions>
   <Import Project="$(MSBuildBinPath)\Borland.Delphi.Targets" />
@@ -40,13 +45,12 @@
       <MainSource>MainSource</MainSource>
     </DelphiCompile>
-    <DCCReference Include="..\BDK50\BDK32_P50\Source\designide.dcp" />
-    <DCCReference Include="..\BDK50\BDK32_P50\Source\rtl.dcp" />
-    <DCCReference Include="..\BDK50\BDK32_P50\Source\VAShared2006.dcp" />
-    <DCCReference Include="..\BDK50\BDK32_P50\Source\vcl.dcp" />
-    <DCCReference Include="..\BDK50\BDK32_P50\Source\vclx.dcp" />
-    <DCCReference Include="ORCtrls.pas" />
-    <DCCReference Include="ORCtrlsDsgn.dcr" />
-    <DCCReference Include="ORCtrlsDsgn.dcr" />
-    <DCCReference Include="ORCtrlsDsgn.pas" />
+    <DCCReference Include="E:\WVEHR\trunk\CPRS-Lib\designide.dcp" />
+    <DCCReference Include="E:\WVEHR\trunk\CPRS-Lib\ORCtrls.pas" />
+    <DCCReference Include="E:\WVEHR\trunk\CPRS-Lib\ORCtrlsDsgn.dcr" />
+    <DCCReference Include="E:\WVEHR\trunk\CPRS-Lib\ORCtrlsDsgn.dcr" />
+    <DCCReference Include="E:\WVEHR\trunk\CPRS-Lib\ORCtrlsDsgn.pas" />
+    <DCCReference Include="E:\WVEHR\trunk\CPRS-Lib\rtl.dcp" />
+    <DCCReference Include="E:\WVEHR\trunk\CPRS-Lib\vcl.dcp" />
+    <DCCReference Include="E:\WVEHR\trunk\CPRS-Lib\vclx.dcp" />
   </ItemGroup>
 </Project>